program bufrcopy
!------------------------------------------------------------------------------!
!BUFRCOPY |COPIA  MENSAGENS BUFR DE UM ARQUIVO PARA OUTRO                | SHSF|
!------------------------------------------------------------------------------|
!                                                                              !
! THIS PROGRAM COPY BUFR MESSAGE FROM A FILE TO ANOTHER USING SELECTION 
! CRITERIA                                                                     !
!                                                                              !
!------------------------------------------------------------------------------!
!DEPENDENCIAS: MBUFR-ADT, STRINGFLIB                                           !
!------------------------------------------------------------------------------!

USE mbufr
use stringflib
!USE msflib  ! FOR USE WITH MICROSOFT POWER STATION/Para compilacao em Windows ( Microsoft Power Station )

implicit none

!{ DECLARATION OF VARIABLES USED BY READ_MBUFR/Declaracao das variaveis utilizadas em read_mbufr
  type(octtype)    ::bufrmessage
  type(sec1type)   ::sec1
  integer          ::NBYTES,BUFR_ED
  integer          ::btype=-1
  integer          ::bsubtype=-1
  integer          ::center=-1
  integer          ::err
  Real,parameter   ::Null=-340282300 !...........................VALUE NULL/valor nulo
  integer          ::reg
  character(len=40)::header !Telecommunications header (40 bytes)


!}

!{ AUXILIARY VARIABLES OF MAIN PROGRAM/variaveis auxiliares do progrma principal
  integer ::i,NM
  integer*2 ::argc
  integer :: iargc
  character(len=255)::infile,outfile
!}



    call getarg2(argname,arg,narg)
    if((len_trim(argname(1))>0).and.(narg>1)) then
     
      do i=1,narg
        if (argname(i)=="i") then !,,,,,,,.....
          infile=arg(i)
          x1=1
        elseif (argname(i)=="o") then !................ Arquivo de saida
          outfile=arg(i)
          x2=1
        elseif (argname(i)=="b") then !...............Tipo de dado de saida
          btype=val(arg(i))
        elseif (argname(i)=="s") then 
          bsubtype=val(arg(i))
        elseif (argname(i)=="c") then 
          center=val(arg(i))
        end if
      end do
      x1=x1*x2
    end if

    if (x1==0) then 
      print *,"+--------------------------------------------------------+"
      print *,"| CPTEC/INPE BUFRCOPY : Copy FM94 BUFR messages          |"
      print *,"| Include MBUFR-ADT module ",MBUFR_VERSION,"     |"
      print *,"+--------------------------------------------------------+"
      print *,"| use:       bufrdump -i infile -o outfile {options}     |"
      print *,"+--------------------------------------------------------+"
      print *,"|            infile = Bufr input file name               |"
      print *,"|            outfile= text output filename               |"
      print *,"+--------------------------------------------------------+"
      print *,"| options:                                               |"
      print *,"|            -b : Select the data type                   |"
      print *,"|            -s : Select the data subtype                |"
      print *,"|            -c : Select the generator center            |"
      print *,"+--------------------------------------------------------+"
      stop
    else 
      print *,"----------------------------------------------"
      print *," CPTEC/INPE BUFRDUMP : Decode FM94 BUFR files "
      print *,"----------------------------------------------"
      print *,":BUFRDUMP: Input filename: ",trim(infile)
      print *,":BUFRDUMP: Output filename: ",trim(outfile)
    endif
   !}
    
	


!{ PROCESS THE DATA READING FOR EACH NF INPUT FILES/Processa a leitura dos dados para cada um dos nf arquivos fornecidos
        REG=0
        NBYTES = 0
        Call OPEN_MBUFR(1, infile)
        open(2,file=outfile,STATUS='unknown',FORM='UNFORMATTED',access='DIRECT',recl=1) 
        nm=0
!{ READ MESSAGES FROM EACH OPENED FILE/Processa a leitura de cada uma das mensagens do arquivo abertor


10    CONTINUE

        nm=nm+1
        Call READBIN_MBUFR(1,bufrmessage, bUFR_ED, sec1,err, header)

        If ((bufrmessage%nocts > 0).and.(IOERR(1)==0)) Then
			!print *, header(9:19)
			write(*,'(i5.5,"T",i3.3,"B",i3.3,a11)')nm,sec1%center,sec1%btype, header(9:19)
					
			do i=1,bufrmessage%nocts
                                REG=REG+1
				write (2,rec=REG) bufrmessage%oct(i)
			end do
			deallocate(bufrmessage%oct)
			goto 10 
		end if
		
  !}

 call Close_mbufr (1)
 close (2)
 close (3)
!}

End



