!======================================================================================!
!	Programa: listasubsets.f90
!	
!	Autor:	  Cavalca Filho, Marcelo (19/08/2013)
!
!	Objetivo: ler os BUFRs e apresentar o total sem duplicatas
!
!======================================================================================!
!		  
!		  
!	Versão:   0.1 - 21/08/2013
!		  > Le os dados bufr e apresenta o total de subsets no mesmo
!		    apresentando o total sem duplicatas.
!
!		  0.2 - 25/08/2013
!		  > Mostra o total de dados em cada arquivo, o total de du-
!		    plicatas no mesmo e o total final, alem de exibir a 
!		    quantidade de arquivos lidos.
!
!		  0.3 - 28/08/2013
!		  > Exibe o resultado em um arquivo ou na tela quando omiti-
!		    da a saida.
!
!		  0.4 - 29/08/2013
!		  > Modo silencioso e modo detalhado adicionados e verifica-
!		    cao para saber se o arquivo de saida ja existe.
!
!		  0.5 - 04/09/2013
!		  > Modo detalhado apresenta agora o numero de estacoes no
!		    arquivo e também consegue ler dados buoy. Para o teste
!		    de duplicatas ele verifica a hora e os segundos, sendo
!		    ainda mais preciso. Pode-se decidir por mostrar somente
!		    um numero de estacao 'x' entrando com a mesma apos o pa-
!		    rametro '-v', e enumerando-as atraves da coluna indice.
!
!		  0.6 - 06/09/2013
!		  > Novo parametro '-d' que mostra somente o dia selecionado
!		    caso o usuario deseje. O parametro '-v' agora pode ter 
!		    argumentos para ordenacao dos dados a serem apresentados.
!
!		  1.0 - 12/09/2013
!		  > Versao completa - inserida junto com o mbufrtools.
!
!		  1.1 - 04/10/2013
!		  > Agora verifica se o nome do arquivo de saida é nulo e se as varia-
!		    veis de entrada sao inteiros. Agora o modo silencioso possui uma
!		    barra de progresso.
!
!		  1.2 - 08/10/2013
!		  > Programa mais robusto, com apresentacoes e verificacoes mais claras
!		    ao usuario.
!
!		  1.3 - 09/10/2013
!		  > Modo silencioso ativado sempre agora para melhor visualizacao do
!		    que esta acontecendo.
!
!		  1.4 - 23/10/2013
!		  > Parâmetro "-s" onde o usuário entra com a faixa de estacoes;
!		    removido a exibicao de arquivos nulos devido a certos parametros
!		    Exibe ao final do arquivo o total final.
!
!		  1.5 - 24/10/2013
!		  > Parametro "-d" atualizado: Agora, ao inves de somente um dia, 
!		    o usuario pode escolher um "range" de dias.
!
!		  1.6 - 29/11/2013
!		  > Agora utiliza o datelib para ordenacao atraves da data.
!		    Utiliza tambem a ordenacao de insercao binaria que e significamente
!		    mais rapida em comparacao a ordenacao por bolha.
!		    Agora o programa checa se o arquivo de entrada e um diretorio ao
!		    inves de gerar um erro na estrutura de saida do programa no meio da
!		    execucao.
!
!		  1.7 - 03/12/2013
!		  > Nova funcionalidade: Caso o usuario entre com o modo verboose sem 
!	 	    dizer o arquivo de saida atraves do parametro "-o" o programa pede
!		    para que entre com o arquivo de saida para dar continuidade. Caso
!		    contrario, o modo simples e executado.
!
!======================================================================================!

!======================================================================================!
!==========__============================______========___=============================!
!=========/  /===_======================/      )======/  /=============================!
!========/  /===(_)=======__===========/  ____/======/  /===============__=============!
!=======/  /====__==____=/ /==____====/  (___=_===__/  /__==____=____=_/ /==____=======!
!======/  /====/ /=/  __) __)(_   )==(___    ) /=/  ) ___ \/  __) __ \  __)/  __)======!
!=====/  /=__=/ /=(_ ( / /==___) /===____)  / (_/  / (==/ )_ ( /  ___) /==(_ (=========!
!====(  (_/  ) (_=__) ) (_=/ _  /===/      /      /   \/ /__) )  (_ / (_=___) )========!
!====\______/\___)___/\___)____/===(______/\__/(_/\_)\__/____/\____)\___)____/=========!
!======================================================================================!

PROGRAM conta

USE MBUFR
USE STRINGFLIB
USE DATELIB
IMPLICIT NONE

! { Declaracao das variaveis utilizadas em read_mbufr 
  integer :: i,j, indestacao, nestacoes, tipoord=-1, diaespec1=-1, diaespec2=-1, mesesp1=-1, mesesp2=-1,x, mem=500
  integer :: inv, qterr, icont, jcont, totalnc, repttotal=0 !.......... Elementos para trabalho na matriz
  integer :: menor=0, maior=99999, mame=1, diamame=1
  real :: julian_date1, julian_date2			!........ Para conversao das datas em caso de ordenacao
  integer, dimension(0:65535,0:9) :: control, var !.......... Matriz com os dados dos subsets
  real, dimension(0:65535,2) :: latlon !.......... Latitude e longitude dos subsets
  character(len=2), dimension(0:65535,3) :: error !.......... Matriz com os dois tipos de erros: duplicata e corrompido
  logical :: verboose=.FALSE., silenc=.TRUE., arq_saida=.FALSE., exist_file, exist_dir, nomoarcomp, ordenar=.FALSE. !.......... Variaveis para controle
  logical :: estacoes=.FALSE., dadovalido=.FALSE.
  character :: apagar	
  integer :: ord_min, ord_med, ord_max		! Variaveis de ordenacao
  real :: val_med, val_fix			! Variaveis de ordenacao
  
  integer :: nss, iostat, ios	! Para verificação de inteiro
  type(sec1type)::sec1	 ! Secao 1
  type(sec3type)::sec3   ! Secao 3
  type(sec4type)::sec4	 ! Secao 4
  
  integer :: MBYTES, err, BUFR_ED      ! Numero de bytes de uma mensagem BUFR
  integer, parameter :: stdout=6	! Para deixar de exibir as saidas do MBUFR no programa
  character(len=*), parameter :: nullfile="/dev/null",terminal="/dev/stdout"     ! Para deixar de exibir as saidas do MBUFR no programa
  
  character(len=1),dimension(65536)::namearg ! Nome dos argumentos!
  character(len=256),dimension(65536)::arg  ! Argumentos!
  integer::narg      ! .Numero de argumentos efetivamente passados!
  integer :: nf, iff                              ! Numero de arquivos na lista 
  integer, dimension(0:65536) :: nc, rept	! Total de subsets e total de repetidas
  character(len=255),dimension(65536):: flist ! Lista com nome dos arquivos 
  character(len=255) :: filename ! Nome do arquivo de saida (opcional)
  
  character(len=80) :: bar=" | ???% [..................................................] ?????/?????   Lidos"
! } 





! { Entrada dos Parametros
nf=0
CALL getarg2(namearg,arg,narg)	  !
IF (Narg>0) THEN
    
    do i=1,narg
	select case (namearg(i))
	case ("i")
	    nf=nf+1
	    flist(nf)=arg(i)
	    x=1
	case ("?")
	    if (x.EQ.1) then
		nf=nf+1
		flist(nf)=arg(i)
	    else if (mame.EQ.2) then
		read(arg(i),'(i5)'),maior
		mame=0
	    else if (diamame.EQ.2) then
		read(arg(i),'(i2,i2)', iostat=ios)diaespec2,mesesp2
		if (ios.NE.0) then
		    print *,"+---------------------------------------------------------------------------+"
		    print *,"|"
		    print *,"| [!] Erro 1: Entrou com um nao inteiro para o dia especifico..."
		    print *,"|"
		    print *,"+---------------------------------------------------------------------------+"
		    stop
		end if
		diamame=0
	    else
		print *,"+---------------------------------------------------------------------------+"
		print *,"|"
		print *,"| [!] Erro 2: Algum argumento invalido! Reveja seus argumentos."
		print *,"|"
		print *,"+---------------------------------------------------------------------------+"
		stop
	    end if
	case ("o")
	    x=0
	    filename=arg(i)
	    arq_saida=.TRUE.
	case ("v")
	    x=0
	    verboose=.TRUE.
 	    if (arg(i).NE.' ') then 
		ordenar=.TRUE.
		select case(arg(i))
		    case('est')
			tipoord=1
		    case('dia')
			tipoord=2
		    case default
			print *,"+---------------------------------------------------------------------------+"
			print *,"|"
			print *,"| [!] Erro 3: Tipo de ordenacao invalida! Veja as opcoes."
			print *,"|"
			print *,"+---------------------------------------------------------------------------+"
			stop
		end select
	    end if
	 case ("q")
	    x=0
	    silenc=.TRUE.
	 case ("m")
	    x=0
	    if (len_trim(arg(i)).NE.0) then
		read(arg(i),'(I7)', iostat=ios)mem
		if (ios.NE.0) then
		    print *,"+---------------------------------------------------------------------------+"
		    print *,"|"
		    print *,"| [!] Erro 4: Entrou com uma quantidade de memoria nao inteiro..."
		    print *,"|"
		    print *,"+---------------------------------------------------------------------------+"
		    stop
		end if
		if (mem.EQ.0) then
		    print *,"+---------------------------------------------------------------------------+"
		    print *,"|"
		    print *,"| [!] Erro 5: Entrou com valor nulo para memoria."
		    print *,"|"
		    print *,"+---------------------------------------------------------------------------+"
		    stop
		end if
	    else 
		print *,"+---------------------------------------------------------------------------+"
		print *,"|"
		print *,"| [!] Erro 6: Valor invalido para quantidade de memoria."
		print *,"|"
		print *,"+---------------------------------------------------------------------------+"
		stop
	    end if
	 case ("d")
	    x=0
	    if (len_trim(arg(i)).EQ.4) then
		select case(diamame)
		    case (1)
			read(arg(i),'(i2,i2)', iostat=ios)diaespec1,mesesp1
			if (ios.NE.0) then
			    print *,"+---------------------------------------------------------------------------+"
			    print *,"|"
			    print *,"| [!] Erro 7: Entrou com um nao inteiro para o dia especifico..."
			    print *,"|"
			    print *,"+---------------------------------------------------------------------------+"
			    stop
			end if
			diamame=2
		    case (0)
			print *,"+---------------------------------------------------------------------------+"
			print *,"|"
			print *,"| [!] Erro 8: Quantidade invalida de entradas para dias..."
			print *,"|"
			print *,"+---------------------------------------------------------------------------+"
			stop
		 end select
	    else 
		print *,"+---------------------------------------------------------------------------+"
		print *,"|"
		print *,"| [!] Erro 9: Entre com < diames >. Ex.: 28 de setembro => 2809"
		print *,"|"
		print *,"+---------------------------------------------------------------------------+"
		stop
	    end if
	 case ("s")
	    x=0
	    select case (mame)
		case (1)
		    read(arg(i),'(i5)'),menor
		    MaMe=2
		case (0)
		    print *,"+---------------------------------------------------------------------------+"
		    print *,"|"
		    print *,"| [!] Erro 10: Quantidade invalida de entradas para estacoes..."
		    print *,"|"
		    print *,"+---------------------------------------------------------------------------+"
		    stop
	    end select
	end select
    end do
end if
! }



! { Se o usuario entrar com a ordem inversa dos valores
if (maior.LT.menor) then
    print *,"+---------------------------------------------------------------------------+"
    print *,"|"
    print *,"| [!] Erro 11: Valor invalido para o range de estacoes."
    print *,"|"
    print *,"+---------------------------------------------------------------------------+"
    stop
end if
! }    




! { Help do programa caso o usuario nao entre com pelo menos 1 arquivo de entrada
if (nf == 0) then
    print *,"+-------------------------------------------------------------+"
    print *,"|    listasubsets - Lista os subsets de uma mensagem bufr     |"
    print *,"|                                                             |"
    print *,"|       USE: listasubsets -i < lista_entrada > { opcoes }     |"
    print *,"+-------------------------------------------------------------+"
    print *,"|                         O P C O E S                         |"
    print *,"|                                                             |"
    print *,"|     -i : Arquivo de entrada                                 |"
    print *,"|     -o : Arquivo de saida                                   |"
    print *,"|     -v : Modo detalhado, podendo escolher ordenacao         |"
    print *,"|     -d : Exibir do dia 'x' ao dia 'y'                       |"
    print *,"|     -m : Quantidade de memoria a se utilizar                |"
    print *,"|     -s : Exibir somente estacoes de 'm' a 'n'               |"
    print *,"|                                                             |"
    print *,"+-------------------------------------------------------------+"
    print *,"|               O P C O E S  D E  O R D E N A C A O           |"
    print *,"|                                                             |"
    print *,"|      dia : Dia                                              |"
    print *,"|      est : Estacao                                          |"
    print *,"|                                                             |"
    print *,"+-------------------------------------------------------------+"
    stop   	        
endif
! }





! {
print *,""
if (len_trim(filename).EQ.0) then
    print *,"+---------------------------------------------------------------------------+"
    print *,"|"
    print *,"| [!] Erro 12: Arquivo de saida com nome nulo."
    print *,"|"
    print *,"+---------------------------------------------------------------------------+"
    stop
endif
! }





! { Cabeçalho
print *,"+-------------------------------------------------------------------------------------+"
print *,"|                                 ~ Lista subsets ~                                   |"
print *,"|"
! }





! { Validaçao dos arquivos de entrada
write(*,*)"| Verificando se os arquivos para leitura existem..."
print*,"|"
iff=1
do while (iff.le.nf)
    inquire(file=flist(iff),exist=exist_file)
    inquire(file="./"//trim(flist(iff))//"/.", exist=exist_dir)
    if ((.not.exist_file).or.(exist_dir)) then
	if (.not.exist_file) then
	    write(*,'(A,A,A)')" | [!] Erro 13: Arquivo para leitura '",trim(flist(iff)),"' nao existe."
	else 
	    write(*,'(A,A,A)')" | [!] Erro 14: Arquivo '",trim(flist(iff)),"' e na verdade um diretorio."
	end if
	print*,"|"
	nf=nf-1
	do i=iff,nf
	    flist(i)=flist(i+1)
	end do
	iff=iff-1
    end if
    iff=iff+1
end do
if (nf.LE.0) then
    print *,"|"
    print *,"| [!] Erro 15: Nenhum arquivo apontado para leitura existe !"    
    print *,"|                                                                                     |"
    print *,"+-------------------------------------------------------------------------------------+"
    print*
    stop
end if
! }





! { Caso modo Verboose sem arquivo de saida
if ((.not.arq_saida).and.(verboose)) then
    print*,"|"
    print*,"| [!] Voce entrou com o modo detalhado mas sem um arquivo de saida."
    print*,"|     Sem o arquivo de saida o modo detalhado e impossivel de ser feito."
    write(*,'(A52)',advance='no')," | [?] Deseja escolher um arquivo de saida? [s/n] > "
    read(*,'(A1)') apagar
    if ((apagar.EQ."s").or.(apagar.EQ."S")) then
	print*,"|"    
	write(*,'(A33)',advance='no')," | Entre com o nome de arquivo : "
	read(*,'(A32)')filename
	if (len_trim(filename).EQ.0) then
	    print*,"|"    
	    print*,"| [!] Erro 16: Nome nulo. O programa sera executado sem o modo verboose..."
	else
	    arq_saida=.TRUE.
	end if
    end if
    print*,"|"    
end if
! }





! { Verificaçao de existencia do arquivo de saida
if (arq_saida) then
    if (index(filename,".txt").EQ.0) filename=trim(filename)//".txt"
    inquire(file=filename,exist=exist_file)
    if (exist_file) then
	write(*,'(A65)',advance='no')" | [?] Arquivo de saida ja existe! Apaga-lo mesmo assim? [s/n] > "
	read(*,'(A1)') apagar
	print *,"|"
	if ((apagar.NE."s").and.(apagar.NE."S")) then
	    print *,"| Usuario nao deseja apagar o arquivo... Finalizando programa..."
	    print *,"|                                                                                     |"
	    print *,"+-------------------------------------------------------------------------------------+"
	    stop
	endif
    endif
    open(100,file=filename,status="unknown") 
endif
! }





! { Avisos ao usuário
! Terminal
if ((nf.GE.40).and.(.not.arq_saida)) then
    print*,"|"
    print*,"| [!] Sao muitos arquivos, eles vao extrapolar o tamanho do terminal."
    print*,"|"
end if
! Memoria
if (mem.GE.15000) then
    print*,"|"
    print*,"| [!] Voce selecionou muita memoria, isso pode travar a maquina um pouco..."
    print*,"|"
end if
! }





! { Mensagem de aviso do modo silencioso
if (silenc) then
    print *,"|"
    if (nf.LE.1) then
	write(*,*)"| Lendo o unico arquivo valido..."
    elseif(nf.GT.1) then
	write(*,*)"| Lendo todos os arquivos validos..."
    endif
    print *,"|"
endif
! }





! { BLOCO PRINCIPAL DO PROGRAMA
nc(0)=0
rept(0)=0
do iff=1,nf
    if (silenc.EQV..TRUE.) then
	j=((iff-1)*100/nf)
	write(unit=bar(4:6),fmt="(I3)") j
	write(unit=bar(61:72),fmt="(I5,A1,I5)") iff-1,"/",nf
	do i=1, (j/2)
	    bar(9+i:9+i)="#"
	enddo
	write(unit=6,fmt="(a1,a80)",advance="no") char(13), bar
    end if
    if (silenc) open(unit=stdout, file=nullfile, status="old")
    CALL OPEN_MBUFR(1, flist(iff),46,18,0)
    indestacao=1	! Para indexacao da estacao
    qterr=0		! Quantidade de mensagens com algum erro
    icont=1		! Variavel controle para a quantidade de mensagens no arquivo
    nc(iff)=0		! Total de mensagens em um arquivo
    rept(iff)=0		! Quantidade de duplicatas em um arquivo
    nestacoes=1		! Numero de estacoes
150 CONTINUE
    CALL READ_MBUFR(1, mem,sec1,sec3,sec4, bUFR_ED, MBYTES,err)
    If ((MBYTES > 0).and.(IOERR(1)==0)) Then 
	do i=1,sec3%nsubsets			! FOR para o total de subsets no arquivo
	    dadovalido=.FALSE.			! Para checagem de dado valido
	    inv=0				! Identificaçao de erro em mensagens com problemas
	    error(icont,:)=""			! Limpar os valores da matriz 'error' para itentificaçao de duplic
	    control(icont,:)=0			! Zerar os valores para detecçao de erro 	
	    latlon(icont,:)=0			! Zerar latlon também para detecçao de erro de leitura
	    control(icont,7)=sec1%bTYPE		! Posiçao da MAT que identifica o tipo da mensagem
	    control(icont,8)=sec1%intbsubTYPE	! Posiçao da MAT que identifica o subtipo da mensagem
	    
	    
	    ! { Inicio da leitura da mensagem
	    do j=1, sec4%nvars
		select case(sec4%d(j,i))
		! ------------------------------- DADOS SYNOP ------------------------------- !
		    ! No. ESTACAO MUNDIAL
		    case (001001)		
			control(icont,0)=sec4%r(j,i)*1000
		    ! No. ESTACAO LOCAL
		    case (001002)		
			control(icont,1)=sec4%r(j,i)+control(icont,0)
		    if ((control(icont,1)>99999).or.(control(icont,1)<-99999).or.(control(icont,1)==0)) inv=1
		! ---------------------------------------------------------------------------- !
			    
		! -------------------------------- DADOS BUOY -------------------------------- !
		    ! No. REGIAO WMO
		    case (001003)		
			control(icont,1)=sec4%r(j,i)*10000
		    ! No. IDENTIFICACAO DA BOIA
		    case (001005)				
			control(icont,1)=sec4%r(j,i)+control(icont,1)
		    ! No. SUBREGIAO WMO
		    case (001020)	
			control(icont,1)=control(icont,1)+sec4%r(j,i)*1000
		    if ((control(icont,1)>99999).or.(control(icont,1)<-99999).or.(control(icont,1)==0)) inv=1
		    ! SUBTIPO BUOY
		    case (002149)
			control(icont,7)=sec4%r(j,i)
		! ---------------------------------------------------------------------------- !
			    
		! ------------------------------- DADOS FIXOS -------------------------------- !
		    ! ANO
		    case (004001)
			if (control(icont,2)==0) control(icont,2)=sec4%r(j,i)
			if ((control(icont,2).GT.9999).or.(control(icont,2).LT.1900)) inv=1
		    ! MES
		    case (004002)						
			if (control(icont,3)==0) control(icont,3)=sec4%r(j,i)
			if ((control(icont,3).GT.12).or.(control(icont,3).LT.1)) inv=1
		    ! DIA
		    case (004003)				
			if (control(icont,4)==0) control(icont,4)=sec4%r(j,i)
			if ((control(icont,4).GT.31).or.(control(icont,4).LT.1)) inv=1
		    ! HORA
		    case (004004)						
			if (control(icont,5)==0) control(icont,5)=sec4%r(j,i)
			if ((control(icont,5).GT.23).or.(control(icont,5).LT.0)) inv=1
		    ! MINUTO
		    case (004005)						
			if (control(icont,6)==0) control(icont,6)=sec4%r(j,i)
			if ((control(icont,6).GT.59).or.(control(icont,6).LT.0)) inv=1
		    ! LATITUDE (HIGH ACCURACY)
		    case (005001)				
			latlon(icont,1)=sec4%r(j,i)
			if ((latlon(icont,1).GT.90).or.(latlon(icont,1).LT.-90)) inv=1
		    ! LONGITUDE (HIGH ACCURACY)
		    case (006001)	
			latlon(icont,2)=sec4%r(j,i)
			if ((latlon(icont,2)>180).or.(latlon(icont,2)<-180)) inv=1	
		! ---------------------------------------------------------------------------- !
		
		! ----------------------- PARA CHECAGEM MENSAGEM VALIDO ---------------------- !
		    ! DIRECAO DO VENTO
		    case (011001)	
			if(sec4%r(j,i).NE.-340282300) dadovalido=.TRUE.
			var(icont,1)=sec4%r(j,i)
		    ! VELOCIDADE DO VENTO
		    case (011002)	
			if(sec4%r(j,i).NE.-340282300) dadovalido=.TRUE.
			var(icont,2)=sec4%r(j,i)
		    ! PRESSAO
		    case (010004)	
			if(sec4%r(j,i).NE.-340282300) dadovalido=.TRUE.
			var(icont,3)=sec4%r(j,i)
		    ! TEMPERATURA
		    case (012101)	
			if(sec4%r(j,i).NE.-340282300) dadovalido=.TRUE.
			var(icont,4)=sec4%r(j,i)
		    ! PONTO DE ORVALHO
		    case (020010)		
			if(sec4%r(j,i).NE.-340282300) dadovalido=.TRUE.
			var(icont,5)=sec4%r(j,i)
		! ---------------------------------------------------------------------------- !
			
		end select 
	    end do 
	    ! } Fim da leitura da mensagem
	    
	    
	    ! { Eliminação de duplicatas e Total de estações nos dias
	    ! Ele verifica também se o usuario entrou com algum dia/mes especifico(variável diaespec/mesesp)
	    if (((diaespec1.EQ.-1).or.(control(icont,4).GE.diaespec1)).and.&
		((mesesp1.EQ.-1).or.(control(icont,3).GE.mesesp1)).and.&
		((diaespec2.EQ.-1).or.(control(icont,4).LE.diaespec2)).and.&
		((mesesp2.EQ.-1).or.(control(icont,3).LE.mesesp2)).and.&
		(control(icont,1).GE.menor).and.(control(icont,1).LE.maior)&
		.and.(dadovalido.EQV..TRUE.)) then
		nomoarcomp=.FALSE.
		do j=1, icont-1		! Verificaçao das duplicatas com todos os parametros da mensagem
		    if ((control(j,1)==control(icont,1)).and.(latlon(j,1)==latlon(icont,1))&
		    .and.(latlon(j,2)==latlon(icont,2)).and.(control(j,2)==control(icont,2))&
		    .and.(control(j,3)==control(icont,3)).and.(control(j,4)==control(icont,4))&
		    .and.(control(j,5)==control(icont,5)).and.(control(j,6)==control(icont,6))&
		    .and.(control(j,7)==control(icont,7)).and.(control(j,8)==control(icont,8))&
		    .and.(error(j,1).NE."RR")) then
			rept(iff)=rept(iff)+1	! Contagem das repetidas
			error(j,1)='RR'
		    end if ! FIM VERIFICACAO DUPLICATA
		    ! -------------------- Numero de estacoes --------------------- !
		    ! Verificaçao da quantidade de estacoes nos dias... Como funciona?
		    ! Ele vai verificar se:
		    !			as estaçoes sao diferentes (control(j,1)) e os dias sao diferentes
		    !			ele ja verificou aquela estaçao antes (error(icont,3) / error(j,1))
		    !			ele ainda pode verificar (nomoarcomp=.FALSE.)
		    ! Porque ele tem que parar de verificar?
		    ! explicacao: se tudo ocorreu bem...
		    if (((control(j,1).NE.control(icont,1)).or.(control(j,4).NE.control(icont,4)).or.(control(j,3).NE.control(icont,3)))&
		    .and.(error(icont,3).NE.'**').and.(error(j,3).NE.'**').and.(nomoarcomp.EQV..FALSE.)) then
			nestacoes=nestacoes+1	! ... o numero de estacoes sera incrementado e...
			error(icont,3)='**'		! ... esse vetor dira que aquela posicao ja esta na contagem ...
		    end if
		    ! ...com isso ele ira verificar se encontra alguma mensagem IDENTICA a ele mesmo e entao...
		    if ((control(j,1).EQ.control(icont,1)).and.(error(icont,3).EQ.'**').and.(error(j,3).EQ.'**')&
		    .and.(nomoarcomp.EQV..FALSE.)) then
			if (control(j,4).EQ.control(icont,4)) then
			    if (control(j,3).EQ.control(icont,3)) then
				error(icont,3)=''
 				nestacoes=nestacoes-1	! ... decrementara o valor de nestacoes porque essa estacao ja estava na contagem e...
				nomoarcomp=.TRUE.		! ... ira setar o valor de nomoarcomp para que nao se faca mais verificacoes...
			    end if
			end if
		    endif
		    ! ... lembrando que a estacao que se encontra nessa posicao ja esta na contagem !
		    ! --------------------------------------------------------------- !
			    
		end do		
		if (inv==1) then
		    qterr=qterr+1
		    error(icont,2)='EE'
		end if
		! }
		
		control(icont,9)=icont
		icont=icont+1	! Para a proxima mensagem!
		
	    end if ! FIM VERIFICACAO SE DIA ESPECIFICO
	    
	    
	end do
	DEALLOCATE(sec3%d,sec4%d,sec4%r,sec4%c) 
	GoTo 150    			
    End If
    CALL CLOSE_MBUFR(1)
    nc(iff)=icont-1			! tem de ser removido 1 do total porque o icont se incrementa no final do loop
    totalnc=totalnc+nc(iff)		! Total de mensagens em todos os arquivos
    repttotal=repttotal+rept(iff)	! Total de duplicatas em todos os arquivos
    if ((verboose).and.(arq_saida)) then
	if (nc(iff).EQ.0) nestacoes=0
	if (nc(iff).NE.0) then
	    write(100,*)"+-----------------+--------------------------------------------------------------------------------+"
	    write(100,'(A,A54,A)')" |                 |  Nome do Arquivo lido : ",flist(iff)," |"
	    write(100,'(A,I5,A,I5,37X,A)')" | Modo detalhado  |  Faixa de estacoes : de ",menor," ate ",maior,"   |"
	    write(100,'(A,I8,24X,A)')" |                 |  Numero de estacoes reportadas para os dias : ",nestacoes," |"
	    write(100,*)"+-----------------+--------------------------------------------------------------------------------+"
	    
	    
	    ! { Bloco de ordenacao (ordenacao binaria)
	    if (ordenar.EQV..TRUE.) then
		do i=2,nc(iff)				
		    
		    ! { Bloco da troca
			! Valor para comparacoes {
			control(0,:)=control(i,:)
			latlon(0,:)=latlon(i,:)
			error(0,:)=error(i,:)
			if (tipoord.EQ.1) val_fix=control(i,1)		
			if (tipoord.EQ.2) val_fix=fjulian(control(i,2),control(i,3),control(i,4),control(i,5),control(i,6),0)
			! }
			    
			ord_min=1		! Valor do inicio
			ord_max=i		! Valor do final das comparacoes
			do while (ord_min.LT.ord_max)
			    ord_med=(ord_min+ord_max)/2		! Valor do elemento medio
			    ! Valor para comparacoes { 
			    if (tipoord.EQ.1) val_med=control(ord_med,1)
			    if (tipoord.EQ.2) val_med=fjulian(control(ord_med,2),control(ord_med,3)&
				,control(ord_med,4),control(ord_med,5),control(ord_med,6),0)
			    ! }
				
			    if (val_med.LE.val_fix) then	! Para reajuste dos valores
				ord_min=ord_med+1
			    else
				ord_max=ord_med
			    end if
			end do
			do j=i,ord_max+1,-1
			    control(j,:)=control(j-1,:)
			    latlon(j,:)=latlon(j-1,:)
			    error(j,:)=error(j-1,:)
			end do
			control(ord_max,:)=control(0,:)
			latlon(ord_max,:)=latlon(0,:)
			error(ord_max,:)=error(0,:)
		    ! } 
			
		end do
	    end if
	    ! }
	    
	    nc(0)=nc(0)+nc(iff)		! Total final
	    rept(0)=rept(0)+rept(iff)	! Total final
	    ! { Exibição final
	    write(100,'(A,I5,A,I5,A,I5,A)')" |  Total = ",nc(iff),". subsets  |  No. Duplic. = ",rept(iff),&
	    ". subsets |   Total s/ Duplic.  = ",nc(iff)-rept(iff),". subsets  |"
	    write(100,*)"+--------+--------+--------+------+------------+-----------+------------+---------+----------------+"                
	    write(100,*)"| Indice | IndArq | Repet. | Erro |  Tipo/Sub  |  Estacao  |    Data    |  Hora   |    Lat/Long    |"                
	    write(100,*)"+--------+--------+--------+------+------------+-----------+------------+---------+----------------+"  
	    do icont=1,nc(iff)
		write(100,101)indestacao,control(icont,9),error(icont,1),error(icont,2)&
		,control(icont,7),control(icont,8),control(icont,1)&
		,control(icont,4),control(icont,3),control(icont,2)&
		,control(icont,5),control(icont,6),latlon(icont,1),latlon(icont,2) 
		indestacao=indestacao+1
	    end do        
	    write(100,*)"+--------+--------+--------+------+------------+-----------+------------+---------+----------------+"    
! 	    write(100,*)""
101         format (' | ',I5,'  | ',I5,'  |  [',A2,']  | [',A2,'] |  ',I4,I4,'  |  ',I7.5,'  | ',I2.2,'/',I2.2,'/',I4,' |  '&
	,I2.2,':',I2.2,'  | ',F6.2,',',F7.2,' | ')
	! formatacao: INDICE.EST.ESPECIF. | INDICE.LISTA | MENS.REPET. | MENS.C/ERRO | TIPO/SUBT. | N.ESTAC. | DIA/MES/ANO | HORA:MIN  |  LAT/LONG |
	! }
    
	end if
! 	write(100,'(A,I5,A,I5,A,I5,A)')" |  Total = ",nc(iff),". subsets  |  No. Duplic. = ",rept(iff),&
! 	". subsets |   Total s/ Duplic.  = ",nc(iff)-rept(iff),". subsets  |"
! 	write(100,*)"+-----------------+--------------------------------------------------------------------------------+"
! 	write(100,'(A,A54,A)')" |                 |  Nome do Arquivo lido : ",flist(iff)," |"
! 	write(100,'(A,I5,A,I5,37X,A)')" | Modo detalhado  |  Faixa de estacoes : de ",menor," ate ",maior,"   |"
! 	write(100,'(A,I8,24X,A)')" |                 |  Numero de estacoes reportadas para os dias : ",nestacoes," |"
! 	write(100,*)"+-----------------+--------------------------------------------------------------------------------+"
	write(100,*)
    endif
    if(silenc) open(unit=stdout, file=terminal, status="old") ! caso voce tenha selecionado o modo silencioso
end do	 
if ((verboose).and.(arq_saida)) then
    write(100,*)"+--------------------------------------------------------------------------------------------------+"
    write(100,'(A,I7,A,I7,A,I7,A)')" | Total de mensagens final: ",nc(0)," - Total de dupĺicatas: ",rept(0)&
    ," - Total sem duplicatas: ",nc(0)-rept(0)," |"
    write(100,*)"+--------------------------------------------------------------------------------------------------+"
end if   

! } FIM BLOCO PRINCIPAL DO PROGRAMA





! { Fim da leitura dos arquivos
if (silenc) then
    bar=" | 100% [##################################################]               Lidos "
    write(unit=bar(61:72),fmt="(I5,A1,I5)") iff-1,"/",nf
    write(unit=6,fmt="(a1,a80)",advance="no") char(13), bar
    print*
end if
! }





! { Bloco de finalizaçao
print*,"|"
write(*,*)"| Arquivos lidos com sucesso! Preparando a apresentacao dos dados..."
if(arq_saida) then
    print *,"| "
    write(*,'(A,A,A)')" | Arquivo de saida < ",trim(filename)," > gerado com sucesso."
end if
print *,"|                                                                                     |"
print *,"+-------------------------------------------------------------------------------------+"
print*
! }





! { Apresentaçao dos dados
if ((arq_saida).and.(.NOT.verboose)) then
    write(100,*)"+----------------------------------------------------------------------+"
    write(100,'(A,34x,I5,A)')" | Numero de arquivos",nf," arquivo(s) |"
    write(100,*)"+------------------------------------+----------------+----------------+"
    write(100,*)"|           Nome do Arquivo          |     Subsets    |   Duplicatas   |"
    write(100,*)"+------------------------------------+----------------+----------------+"        
    do iff=1,nf
	write(100,'(A,A35,A,I5,A,I5,A)')" | ",flist(iff),"| ",nc(iff),". subsets | ",rept(iff),". subsets |"
    end do
    write(100,*)"|                                    |                |                |"
    write(100,'(A,28X,A,I7,A,I7,A)')" | Total "," | ",totalnc,". subs. | ",repttotal,". subs. |"
    write(100,*)"+------------------------------------+----------------+----------------+"
    write(100,'(A,17X,I7,A)')" | Total de subsets sem as duplicatas.",totalnc-repttotal,". Subsets |"
    write(100,*)"+----------------------------------------------------------------------+"
    close(100)
elseif (.NOT.arq_saida) then
    call sleep(3)
    write(*,*)" "
    write(*,*)"+----------------------------------------------------------------------+"
    write(*,'(A,34x,I5,A)')" | Numero de arquivos",nf," arquivo(s) |"
    write(*,*)"+------------------------------------+----------------+----------------+"
    write(*,*)"|           Nome do Arquivo          |     Subsets    |   Duplicatas   |"
    write(*,*)"+------------------------------------+----------------+----------------+"
    do iff=1,nf
	write(*,'(A,A35,A,I5,A,I5,A)')" | ",flist(iff),"| ",nc(iff),". subsets | ",rept(iff),". subsets |"
    end do
    write(*,*)"|                                    |                |                |"
    write(*,'(A,28X,A,I7,A,I7,A)')" | Total "," | ",totalnc,". subs. | ",repttotal,". subs. |"
    write(*,*)"+------------------------------------+----------------+----------------+"
    write(*,'(A,17X,I7,A)')" | Total de subsets sem as duplicatas.",totalnc-repttotal,". Subsets |"
    write(*,*)"+----------------------------------------------------------------------+"
    print*
    if (verboose) print *,"[!] Modo detalhado nao possivel sem arquivo de saida! "
    print*
endif
! }


END PROGRAM conta

